{% include target ~ "-header.spec.inc" ignore missing %}
# Generated by rust2rpm {{ generator_version }}
%bcond_without check
{% set only_main = False %}
{% if not include_main %}
%global debug_package %{nil}
{% elif not include_devel %}
  {% set only_main = True %}
{% endif %}

%global crate {{ metadata.name }}
{% if metadata.name != crate %}
%global real_crate {{ crate }}
{% endif %}

Name:           {{ pkg_name }}
Version:        {{ metadata.version }}
Release:        {{ pkg_release }}
{% if metadata.description is none %}
Summary:        # FIXME
{% else %}
Summary:        {{ metadata.summary }}
{% endif %}
{% if rust_group is defined %}
Group:          {{ rust_group }}
{% endif %}

{% if metadata.license != license %}
# Upstream license specification: {{ metadata.license|default("(missing)") }}
{% endif %}
License:        {{ license|default("# FIXME") }}
{% if license_comments is not none %}
{{ license_comments }}
{% endif %}
URL:            https://crates.io/crates/{{ crate }}
Source:         %{crates_source}
{% if patch_file_automatic is not none %}
# Automatically generated patch to strip foreign dependencies
Patch:          {{ patch_file_automatic }}
{% endif %}
{% if patch_file_manual is not none %}
{% if target == "opensuse" %}
# PATCH-FIX-OPENSUSE {{ patch_file_manual }} — Manually created patch for downstream crate metadata changes
{% else %}
# Manually created patch for downstream crate metadata changes
{% endif %}
Patch:          {{ patch_file_manual }}
{% endif %}

{% if target != "fedora" %}
ExclusiveArch:  %{rust_arches}

{% endif %}
BuildRequires:  rust-packaging >= 21
{% if all_features %}
  {% set cargo_args = " -a" %}
{% endif %}
{% if not generate_buildrequires %}
  {% if not all_features %}
    {% set buildrequires = normalize_deps(metadata.requires("default", resolve=True))|sort %}
  {% else %}
    {% set buildrequires = normalize_deps(metadata.all_dependencies)|sort %}
  {% endif %}
  {% set testrequires = normalize_deps(metadata.dev_dependencies)|sort %}
  {% set has_buildrequires = (buildrequires + testrequires)|length > 0 %}
  {% if has_buildrequires and not only_main %}
  {% endif %}
  {% for req in buildrequires %}
BuildRequires:  {{ req }}
  {% endfor %}
  {% if testrequires|length > 0 %}
%if %{with check}
    {% for req in testrequires %}
BuildRequires:  {{ req }}
    {% endfor %}
%endif
  {% endif %}
  {% for req in to_list(distconf.get("buildrequires"))|sort %}
BuildRequires:  {{ req }}
  {% endfor %}
  {% if distconf.get("testrequires") %}
%if %{with check}
  {% for req in to_list(distconf.get("testrequires"))|sort %}
BuildRequires:  {{ req }}
  {% endfor %}
%endif
  {% endif %}
  {% if has_buildrequires and not only_main %}
  {% endif %}
{% endif %}

%global _description %{expand:
{% if metadata.description is none %}
%{summary}.
{%- else %}
{{ metadata.description|wordwrap }}
{%- endif %}
}

%description %{_description}

{% if include_main %}
  {% if not only_main %}
  {% endif %}
%package     -n %{crate}
Summary:        %{summary}
  {% if rust_group is defined %}
Group:          # FIXME
  {% endif %}
  {% for req in to_list(distconf.get("bin.requires"))|sort %}
Requires:       {{ req }}
  {% endfor %}

%description -n %{crate} %{_description}

%files       -n %{crate}
  {% if license_files|length > 0 %}
    {% for file in license_files %}
%license {{ file }}
    {% endfor %}
  {% else %}
# FIXME: no license files detected
  {% endif %}
  {% for file in doc_files %}
%doc {{ file }}
  {% endfor %}
  {% for bin in bins %}
%{_bindir}/{{ bin.name }}
  {% endfor %}
  {% if not only_main %}
  {% endif %}

{% endif -%}

{% if include_devel %}
  {% set features = metadata.dependencies.keys()|list %}
  {% do features.remove(None) %}
  {% do features.remove("default") %}
  {% set features = features|sort %}
  {% do features.insert(0, None) %}
  {% do features.insert(1, "default") %}
  {% for unwanted in to_list(distconf.get("unwanted-features")) %}
    {% do features.remove(unwanted) %}
  {% endfor %}
  {% for feature in features %}
    {% if feature is none %}
      {% set pkg = "   devel" %}
      {% set conf_prefix = "lib" %}
    {% else %}
      {% set pkg = "-n %%{name}+%s-devel"|format(feature) %}
      {% set conf_prefix = "lib+%s"|format(feature) %}
    {% endif %}
%package     {{ pkg }}
Summary:        %{summary}
    {% if rust_group is defined %}
Group:          {{ rust_group }}
    {% endif %}
BuildArch:      noarch
    {% if include_provides %}
Provides:       {{ metadata.provides(feature) }}
    {% endif %}
    {% if include_requires %}
Requires:       cargo
      {% for req in normalize_deps(metadata.requires(feature))|map("string")|sort %}
Requires:       {{ req }}
      {% endfor %}
    {% endif %}
    {% for req in to_list(distconf.get("%s.requires"|format(conf_prefix)))|sort %}
Requires:       {{ req }}
    {% endfor %}

%description {{ pkg }} %{_description}

This package contains library source intended for building other packages which
use {% if feature is not none %}the "{{ feature }}" feature of {% endif %}the "%{crate}" crate.

%files       {{ pkg }}
    {% if feature is none %}
      {% if license_files|length > 0 %}
        {% for file in license_files %}
          {% if relative_license_paths %}
%license {{ file }}
          {% else %}
%license %{crate_instdir}/{{ file }}
          {% endif %}
        {% endfor %}
      {% else %}
# FIXME: no license files detected
      {% endif %}
      {% for file in doc_files %}
%doc %{crate_instdir}/{{ file }}
      {% endfor %}
%{crate_instdir}/
    {% else %}
%ghost %{crate_instdir}/Cargo.toml
    {% endif %}

  {% endfor %}
{% endif -%}

%prep
{% if metadata.name != crate %}
%autosetup -n %{real_crate}-%{version_no_tilde} -p1
{% else %}
%autosetup -n %{crate}-%{version_no_tilde} -p1
{% endif %}
%cargo_prep

{% if generate_buildrequires %}
%generate_buildrequires
%cargo_generate_buildrequires{{ cargo_args }}
  {% for req in to_list(distconf.get("buildrequires"))|sort %}
echo {{ "%r" | format(req) }}
  {% endfor %}
  {% if distconf.get("testrequires") %}
%if %{with check}
  {% for req in to_list(distconf.get("testrequires"))|sort %}
echo {{ "%r" | format(req) }}
  {% endfor %}
%endif
  {% endif %}

{% endif -%}

%build
%cargo_build{{ cargo_args }}

%install
%cargo_install{{ cargo_args }}

%if %{with check}
%check
%cargo_test{{ cargo_args }}
%endif

%changelog
{% if rpmautospec %}
%autochangelog
{%- else %}
{%- if auto_changelog_entry -%}

  {% include target ~ "-changelog.spec.inc" %}
{% endif %}
{% endif %}
